package tests;

import java.text.ParseException;
import java.text.SimpleDateFormat;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import service.IService;
import entites.Personne;

public class InitDB {

	// couche service
	private static IService service;

	// constructeur
	public static void main(String[] args) throws ParseException {
		// configuration de l'application
		ApplicationContext ctx = new ClassPathXmlApplicationContext("spring-config.xml");
		// couche service
		service = (IService) ctx.getBean("service");
		// on vide la base
		clean();
		// on la remplit
		fill();
		// on vrifie visuellement
		dumpPersonnes();
	}

	// affichage contenu table
	private static void dumpPersonnes() {
		System.out.format("[personnes]%n");
		for (Personne p : service.getAll()) {
			System.out.println(p);
		}
	}

	// remplissage table
	public static void fill() throws ParseException {
		// cration personnes
		Personne p1 = new Personne("p1", "Paul", new SimpleDateFormat("dd/MM/yy").parse("31/01/2000"), true, 2);
		Personne p2 = new Personne("p2", "Sylvie", new SimpleDateFormat("dd/MM/yy").parse("05/07/2001"), false, 0);
		// qu'on sauvegarde
		service.saveArray(new Personne[] { p1, p2 });
	}

	// supression lments de la table
	public static void clean() {
		for (Personne p : service.getAll()) {
			service.deleteOne(p.getId());
		}
	}
}
