package dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import entites.Personne;

public class Dao implements IDao {

	@PersistenceContext
	private EntityManager em;

	
	public void deleteOne(Integer id) {
		Personne personne = em.find(Personne.class, id);
		if (personne == null) {
			throw new DaoException(2);
		}
		em.remove(personne);
	}

	@SuppressWarnings("unchecked")
	
	public List<Personne> getAll() {
		return em.createQuery("select p from Personne p").getResultList();
	}

	@SuppressWarnings("unchecked")
	
	public List<Personne> getAllLike(String modele) {
		return em.createQuery("select p from Personne p where p.nom like :modele").setParameter("modele", modele)
				.getResultList();
	}

	
	public Personne getOne(Integer id) {
		return em.find(Personne.class, id);
	}

	
	public Personne saveOne(Personne personne) {
		em.persist(personne);
		return personne;
	}

	
	public Personne updateOne(Personne personne) {
		return em.merge(personne);
	}

}
