package service;

import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import dao.IDao;

import entites.Personne;

// ttes les mthodes de la classe se droulent dans une transaction
@Transactional
public class Service implements IService {

	// couche [dao]
	private IDao dao;

	public IDao getDao() {
		return dao;
	}

	public void setDao(IDao dao) {
		this.dao = dao;
	}

	
	public void deleteArray(Personne[] personnes) {
		for (Personne p : personnes) {
			dao.deleteOne(p.getId());
		}
	}

	
	public void deleteOne(Integer id) {
		dao.deleteOne(id);
	}

	
	public List<Personne> getAll() {
		return dao.getAll();
	}

	
	public List<Personne> getAllLike(String modele) {
		return dao.getAllLike(modele);
	}

	
	public Personne getOne(Integer id) {
		return dao.getOne(id);
	}

	
	public Personne[] saveArray(Personne[] personnes) {
		Personne[] personnes2 = new Personne[personnes.length];
		for (int i = 0; i < personnes.length; i++) {
			personnes2[i] = dao.saveOne(personnes[i]);
		}
		return personnes2;
	}

	
	public Personne saveOne(Personne personne) {
		return dao.saveOne(personne);
	}

	
	public Personne[] updateArray(Personne[] personnes) {
		Personne[] personnes2 = new Personne[personnes.length];
		for (int i = 0; i < personnes.length; i++) {
			personnes2[i] = dao.updateOne(personnes[i]);
		}
		return personnes2;
	}

	
	public Personne updateOne(Personne personne) {
		return dao.updateOne(personne);
	}

}
